; Params.asm
; (C) 2001-2005, Andreas Berg. All Rights Reserved.

; Description: Get Command line parameters.

.model tiny
.com
.code
.org   100h

; Get page
mov    ah,0fh                          ; AH = 0fh
int    10h                             ; INT 10h: Get screen info
mov    [pageNum],bh                    ; pageNum = bh (store page number)

; Get Command line parameters...
push   cx                              ; stack = CX
push   si                              ; stack = SI
push   di                              ; stack = DI
mov    cl,cs:[80h]                     ; CL = CS:80h
cmp    cl,0                            ; Is CL = 0? (is anything entered?)
je     skipP                           ; If = 0, jump to "skipP"
dec    cl                              ; CL = CL - 1
mov    si,82h                          ; SI = 82h          
lea    di,buffer                       ; DI -> buffer         
rep    movsb                           ; Copy to buffer                                
mov    byte ptr [di],0                 ; Add 0 to the last byte in the buffer
skipP:
pop    di                              ; DI = stack
pop    si                              ; SI = stack
pop    cx                              ; CX = stack

; Display main text...
lea    si,title                        ; SI -> title
call   print_String                    ; Print string

; Check if any commands entered...
xor    cx,cx                           ; CX = 0
lea    si,buffer                       ; SI -> buffer
chkChar:
mov    al,byte ptr [si]                ; AL -> SI[pos]
cmp    al,0                            ; Is AL = 0?
je     endChk                          ; If yes, jump to "endChk"
inc    si                              ; Point to next character
inc    cx                              ; CX = CX + 1
jmps   chkChar                         ; Check next character
endChk:
cmp    cx,0                            ; Is CX = 0?
jne    file_ok                         ; If not, jump to "file_ok"
lea    si,notEnter                     ; SI -> notEnter
call   print_String                    ; Print string
jmp    done                            ; Jump to "done"
file_ok:

; Print info...
lea    si,enterTxt                     ; SI -> enterTxt
call   print_String                    ; Print string
lea    si,buffer                       ; SI -> buffer
call   print_String                    ; Print string
lea    si,newLine                      ; SI -> newLine
call   print_String                    ; Print string

done:
int      20h                           ; Terminate COM file

; Print string procedure
print_String:
   mov   al,byte ptr [si]              ; AL = SI[pos]
   cmp   al,0                          ; Is AL = 0?
   je    print_done                    ; If yes, jump to "print_done"
   mov   ah,0eh                        ; AH = 0eh
   mov   bh,[pageNum]                  ; BH = pageNum
   int   10h                           ; INT 10h: Print character
   inc   si                            ; Point to the next character
   jmps  print_String                  ; Jump to "print_string"
print_done:
ret                                    ; Return from procedure

; Data
buffer   array byte 0, 256
title    db   'Params 0.03 / (C) 2001-2005, Andreas Berg. '
         db   'All Rights Reserved.',13,10
newLine  db   13,10,0
notEnter db   '[Nothing entered]',13,10,0
enterTxt db   'Entered parameter data: ',0
pageNum  db   0

end
